<?php

/* astrosortfilegen.php

This script outputs astrosorted lists of music, musician link lists, and new song lists, just like the lists on Astroblahhh.Com.  This is what I use to generate those lists. 

It can also output astrosorted lists for my own private use, which have less information about the songs and no musician links. */


require ("vglib.php");

CheckCookie();

require ("astrosort-pagetext.php");
require ("vglinklib.php");
require ("lib-numtopla.php");

session_start();

//Value of the radio box from the form.  Value should be either Public or Private.
$listtype=$_POST['listtype'];


//Values of the checkboxes from the form:

$shortlist=$_POST['shortlist'];
$multipage=$_POST['multipage'];
$outputfiles=$_POST['outputfiles'];
$musicianlinks=$_POST['musicianlinks'];
$displayeditlinks=$_POST[displayeditlinks];



/*function GoBackToForm()
{	
	header("Location: astrosortfilegenform.php");
	exit;
}*/

//This can be switched to "whenmodified" if desired, in case you
//want to have "New" next to files which were modified since
//a certain date, rather than added since a certain date:

$when="whenmodified";


/* The following paths must have a / at the end of the line.

These are the variables you might want to edit if you want to change the output file location. However, if you don't have a CSS file titled a.css two directories up from the new location, then, there will be some cosmetic problems...*/

$htdocspath="C:/xampp/htdocs/";
$amodbdir="amodb/";

$partialprivatepath="output/private/";
$privatepath=$htdocspath . $amodbdir . $partialprivatepath;


$partialmainpath = "output/public/";
$mainpublicpath=$htdocspath . $amodbdir . $partialmainpath; 

$otherpublicpath = $htdocspath . $amodbdir . $partialmainpath;
	//for musician list


$editpath="http://localhost/amodb/editsongform.php?id=";


//I'll uncomment these (and comment out the above paths) so I can
//easily update the music list for Astroblahhh.Com.

//$partialmainpath = "AC-Mirror/music/astrosort/";
//$mainpublicpath = $htdocspath . $partialmainpath;
//$otherpublicpath = $htdocspath . $partialmainpath;


//The search queries the user might have entered:
$customsqlquery = $_POST[customsqlquery];
$searchquery = $_POST[searchquery];


//The date and/or time the user might have entered:
$newsince=makeintounixtime($_POST['newsince']);


//The function used to give the $newsince variable its value.
//If the user didn't input a date/time, then the current 
//date/time is used and, via the variable $timestampisfornow, 
//a note is made of the fact that the user didn't input a time.

function makeintounixtime ($str)
{	global $timestampisfornow;
	if (($timestamp = strtotime($str)) === false) 
	{
		$timestamp=time();
		$timestampisfornow=true;
	}
	return $timestamp;
}


/* Next, based on the type of astrosorted file the user wants, segments of the SQL query that will be issued must be changed. */

$orderquerysegment="ORDER BY vgSongDetails.label1, vgSongDetails.label2, vgSongDetails.label3";

if ($listtype=="Private")
{	$private="y";
	$privatequerysegment = "vgSongDetails.filename, vgSongDetails.localfolder, ";
}
else if ($listtype=="Public")
{	$public="y";
	//$publicquerysegment =  "url, ";
	$publicquerysegment2 = "AND vgSongDetails.urltype NOT IN ('PRIV','SPC','VGM2','MID')
AND vgSongDetails.temphide = 'n'\n";
}
if ($shortlist)
{	//unset($outputfiles);
	$orderquerysegment="AND unix_timestamp(vgSongDetails.$when)>$newsince
		AND vgSongDetails.nonewlabel ='n'
		ORDER BY vgSongDetails.urltype, vgSongDetails.$when";
}
if (!$shortlist)
{	$notshortlistquerysegment .= "vgSongDetails.sublabels, vgSongDetails.label1, vgSongDetails.label2, vgSongDetails.label3, ";
};


//Just a handy little function.

function restrimcomma ($value)
{	$res=substr ($value, 0, -2);
	return $res;
}

function trimcomma(&$value)
{	$value=substr ($value, 0, -2);
}


/* Now, we already start outputting the results page, since for some reason I didn't feel like bouncing the user back to the original page when an error happens. */

echo "<html>
 <head>
   <TITLE>Generated Astrosort File</TITLE>

<link rel=stylesheet href=\"css/a.css\" type=\"text/css\">

<style type=\"text/css\">";

echo GetCss("sort2");


echo "</style><center><h1>Generated Astrosort File</h1>";

//And finally, we connect to the database.

$handle=ConnectToDb();

if ($customsqlquery)	//If the user input a custom SQL query, we don't
				//have to do anything complicated.

{	$query_to_issue="SELECT " . $customsqlquery;
}
else if ($searchquery)	//If the user input a search query in what I call
				//AMODBQL (AMODB query language), then, we need to
				//include the library with the AMODBQL parser.
{
	include ("lib-search.php");
	$query_part2=ParseSearchQuery($searchquery);

	if ($roletablequery)
	{
		$roletablesornot=", vgNames, vgRolesAndSongs";
		
		$rolequerystuff="AND vgRolesAndSongs.entity_id = vgNames.entity_id
AND vgSongDetails.song_id = vgRolesAndSongs.song_id";
	}
	
	if ($tagtablequery)
	{	
		$tagtablesornot =", tags, songtagmap";
		$tagquerystuff="AND vgSongDetails.song_id = songtagmap.song_id
AND Tags.tag_id = songtagmap.tag_id";
	}
	

	$query_to_issue = "SELECT vgSongDetails.song_id, vgSongDetails.title, vgSongDetails.urltype, vgSongDetails.filesize, vgSongDetails.hours, vgSongDetails.mins, vgSongDetails.secs, vgSongDetails.warning, vgSongDetails.comment, vgSongDetails.vocals, vgSongDetails.profanity, vgSongDetails.volumewarning, vgSongDetails.grating, vgSongDetails.disturbing, vgSongDetails.nonewlabel, vgSongDetails.url, $privatequerysegment $publicquerysegment $notshortlistquerysegment unix_timestamp(vgSongDetails.$when) as whendate
	
	FROM vgSongDetails$roletablesornot $tagtablesornot
WHERE vgSongDetails.urltype != 'oops'
AND vgSongDetails.deleted = 'n'
AND vgSongDetails.urltype != 'STRM'
AND vgSongDetails.label1>0
$publicquerysegment2
$rolequerystuff
$tagquerystuff
" . $query_part2 . " 
$orderquerysegment\n\n";

}
else	//If the user input neither a custom SQL query nor an AMODBQL query...
{
	$query_to_issue = "SELECT song_id, title, urltype, filesize, hours, mins, secs, warning, comment, vocals, profanity, volumewarning, grating, disturbing, nonewlabel, url, $privatequerysegment $publicquerysegment $notshortlistquerysegment unix_timestamp(vgSongDetails.$when) as whendate
FROM vgSongDetails
WHERE urltype !='oops'
AND vgSongDetails.deleted = 'n'
AND vgSongDetails.urltype != 'STRM'
AND label1>0
$publicquerysegment2
$orderquerysegment";

}

//Now the query is fully constructed, so, we issue it.

$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());


//OK, next, we display information about what kind of astrosort file is being
//displayed and/or output.

$numofsongs=mysql_num_rows($query_result);

echo "\n\nNumber of songs: $numofsongs<p><b>";

if ($public)
{	echo "Public ";
	$displaypath=$mainpublicpath;
}
else if ($private)
{	echo "Private ";
	$displaypath=$privatepath;
}
if ($shortlist)
{	echo "Shortlist ";
}
echo "Astrosort Page<br>";
if ($multipage)
{	echo "Multipage<br>";
}
if ($displayeditlinks)
{	echo "with Edit Song Links<br>";
}
if ($musicianlinks)
{	echo "with Musician Links<br>";
	if ($outputfiles)
	{	$displaypath .= "<br>$otherpublicpath";
	}	
}
if ($outputfiles)
{	echo "Displayed and Output<br>";
	echo $displaypath;
}
else
{	echo "Displaying Only, No Output";
}
echo "</b></center><div id=\"maintext\">";

if ($searchquery)
{
	echo "<p><b>Your search query:</b><p><pre>$searchquery</pre>
	<p>
	<br>
	<b>SQL query generated:</b><p><pre>$query_to_issue</pre>";
}
else 
{	echo "<b>Your SQL query</b>: <p><pre>$query_to_issue</pre><p><br>";
}


if ($numofsongs==0)	//Then something went awry.  
{	echo "<hr width=25%><p>";
	if ($shortlist)
	{	if ($timestampisfornow)
		{	echo "</b>Please input an earlier date and time. ";
		}
		$newsinceformat=date('r', $newsince);
		echo "</b>There are no songs that have a date/time newer than $newsinceformat in their '$when' field.";
	}
	if ($searchquery || $customsqlquery)
	{	echo "</b>There were no results found by your search.";
	}
	exit;
}

echo "<ol>";

$numrows=$numofsongs;

		//Then we run through and grab every song id selected...

while ($x<$numrows)
{
	$songids[$x+1]=mysql_result($query_result, $x, 'song_id');
	$x++;
}
		//...and make it into a string separated by commas...

	$songidstring=implode(", ",$songids);


		//Then, we create and issue a second query to get the sources and performers just for the song ids selected.

$query_to_issue2 = "SELECT vgNames.name, vgNames.entity_id, vgRolesAndSongs.song_id, vgRolesAndSongs.role

FROM vgNames, vgRolesAndSongs

WHERE vgRolesAndSongs.song_id in ($songidstring)
AND vgNames.spelling_id = vgRolesAndSongs.spelling_id 
AND (vgRolesAndSongs.role = 'source' OR vgRolesAndSongs.role = 'performer')

ORDER BY song_id, generic_id ASC";

	$query_result2 = mysql_query($query_to_issue2,$handle) or die(mysql_error());


$numrows=mysql_num_rows($query_result2);


/* Then, some stuff that might make your brain hurt, which uses "variable variables" to deal with the role stuff.  Man, I don't even know how I wrote this, I can barely figure it out as I read over it again... the important thing, though, is that it works. */

if ($numrows>0)
{
	$x=0;

	//Slurps every line of the results into the array $info:

	while ($info[$x] = mysql_fetch_array($query_result2) )
	{
		$x++;
	}


	//Then we deal with the results line by line:

	$thisline=0;
	while ($thisline<$x)
	{
		$song_id=$info[$thisline]['song_id'];

		$name=$info[$thisline]['name'];
		$role=$info[$thisline]['role'];

		$thisrolearray = $role . "names";

		if ($thisrolearray!="sourcenames")
		{	
			$entid=$info[$thisline]['entity_id'];

			//Here we get the lists of performers, and, depending on
			//the type of output, we might or might not output musician
			//links for those names.

			if ($private)
			{	${$thisrolearray}[$song_id] .= "$name, ";
			}
			else
			{	${$thisrolearray}[$song_id] .= "<a target=\"Mu\" href=\"";

				if ($shortlist)
				{
					${$thisrolearray}[$song_id] .= "http://astroblahhh.com/music/astrosort/musicianlinks.shtml#$entid\">$name</a>, ";

				}
				else
				{	${$thisrolearray}[$song_id] .= "musicianlinks.shtml#$entid\">$name</a>, ";
				}
			}
		}
		else	//if it's a source name we're dealing with on this line...
		{	${$thisrolearray}[$song_id] .= "$name, ";
		}

	/* Then, we record what roles are present with this song ID. Typically songs have at least one source name and one performer, but sometimes no, because the only mandatory fields for an astrosorted song are astrosort label #1 and the title. */

		$rolespresentin[$song_id][] = $role;

		$thisline++;
	}

	/* Then we go to a whole lot of effort for something as simple as trimming the comma off the end of each role array for each song. */

	$len_array=(count($songids));

	$x=1;
	while ($x<=$len_array)
	{	$thissongid=$songids[$x];

		if (is_array($rolespresentin[$thissongid]))
		{	$rolespresentin[$thissongid]=array_unique($rolespresentin[$thissongid]);
		
			$thisnumofroles=count($rolespresentin[$thissongid]);
			$y=0;
		
			while ($y<$thisnumofroles)
			{
				$thisrole=array_pop($rolespresentin[$thissongid]);
				$thisrolearray=$thisrole . "names";

				trimcomma(${$thisrolearray}[$thissongid]);

				$y++;
			}
		}
		$x++;
	}
}


//Just a bit of setting up...

$prevlabel1=0;
$prevlabel2=0;
$prevlabel3=0;


//OK, now we start building the rest of the astrosort page.

//**************Planet link bar construction:

if ($shortlist)	 //then, no planet link bar needed in this case.
{	$planetlinkbar="";
}
else //if it's not a shortlist, then, we need to put together a planet link bar.
{
	if ($multipage)	//Then we want the planet link bar to link to other pages.

	{	$planetlinkbarstart="<div class=\"navlinks\"><hr noshade><p><a href=\"mercury.shtml\">Mercury</a> | <a href=\"venus.shtml\">Venus</a> | <a href=\"mars.shtml\">Mars</a> | <a href=\"jupiter.shtml\">Jupiter</a> |  <a href=\"saturn.shtml\">Saturn</a> | <a href=\"uranus.shtml\">Uranus</a> | <a href=\"neptune.shtml\">Neptune</a> | <a href=\"pluto.shtml\">Pluto</a>";
	}
	else	//If it's not multipage, though, then, we just link to anchor links on the same page.
	{
		$planetlinkbarstart="<div class=\"navanchs\"><hr><p><a href=\"#mercury\">Mercury</a> | <a href=\"#venus\">Venus</a> | <a href=\"#mars\">Mars</a> | <a href=\"#jupiter\">Jupiter</a> | <a href=\"#saturn\">Saturn</a> | <a href=\"#uranus\">Uranus</a> | <a href=\"#neptune\">Neptune</a> | <a href=\"#pluto\">Pluto</a>";
	}
	$planetlinkbarend="<p><hr></div>";
	if ($private) 	//Then, all we have to do is put the start and end together to get the final bar.
	{
		$planetlinkbar=$planetlinkbarstart . $planetlinkbarend;
	}
	else if ($public)	//The public one has some additional stuff.
	{	
		$planetlinkbar = $planetlinkbarstart . " | <a href=\"systemdesc.shtml#labels\">labels</a> | <a href=\"systemdesc.shtml#summaries\">summaries</a>" . $planetlinkbarend;
		
	}
}

//**************End of planet link bar construction.

/* OK, and more stuff to create the display version of the page as well as the  version which will be output to a file (if there is one).  This is more complicated than I'd like it to be, but, oh, well, at least it works. */

if (!$shortlist)
{

	if ($multipage)
	{

		$pagetoptemplate .= GetCss("sort");
		if ($public)
		{	$pagetoptemplate .= GetPageSubheader(1);
		}
		else
		{	$pagetoptemplate .= CloseCss();
		}
		$pagetoptemplate .= "<p><ol>";
	}

	if ($private && !$multipage)
	{
		$outputtext="<html><head><title>Private Astrosorted List of Songs</title><link rel=stylesheet href=\"../../css/a.css\" type=\"text/css\"><style type=\"text/css\">";
		$outputtext .= GetCss("sort");

		$outputtext .= CloseCss();
		$outputtext .= "<ol>";
	}
	else if ($public)
	{
		if ($outputfiles)
		{	//Then we output a fresh copy of the description of the
			//astrosorting system of music organization, in case I 
			//edited it.  Could comment this out, actually, since I
			//probably won't be editing the description all that often.

			$descoutputtext = GetPageHeader("Description of Astrosorting System of Music Organization");
				$descoutputtext .= ".v, .w
{	word-spacing: 5px;
	font-weight: bold;
}

.w
{
	color: red;
}

td .sum, th .sum, table .sum
{
	border-color: maroon;
	border-style: solid;
	border-width: 1px 1px 0 0;

}

table .sum
{	border-width: 1px 1px 1px 1px;
}

.sum th, .sum td, .sum tr
{	background-color: black;
}
.sum th
{	color: orange;
}
.sum td
{	color: orange;
}
";

			$descoutputtext .= GetPageSubheader(0);
			$descoutputtext .= GetDesc();
			$descoutputtext .= GetPageFooter(0);

			$openthis = $mainpublicpath . "systemdesc.shtml";	
			$filehandle = fopen($openthis, "w");
			fwrite ($filehandle, $descoutputtext);
			fclose ($filehandle);
		}
		if (!$multipage)
		{
			$outputtext = GetPageHeader("Astrosorted Music List");
			$outputtext .= GetCss("sort");
			$outputtext .= GetPageSubheader(1);
			$outputtext .= "<ol>";
		}
	}

	if ($multipage)
	{
		$outputtext = GetPageHeader("Astrosorted Music - Mercury");
		$outputtext .= $pagetoptemplate;
	}

}

//Then, we rewind to the beginning of the query result, since when
//we grabbed every song ID way up before this, the internal data 
//pointer thing was left at the end of the query result, but now 
//we want to cycle through every row again so as to be able to
//output the song information.

mysql_data_seek($query_result,0);

$x=0;

while ($song_info = mysql_fetch_array($query_result) )
{
	$song_id=$song_info['song_id'];
	$filename=$song_info['filename'];
	$filesize=$song_info['filesize'];
	$filetype=$song_info['filetype'];
	$sublabels=$song_info['sublabels'];

	$localfolder=$song_info['localfolder'];
	$fulllocalpath=$localfolder . "/" . $filename;

	$comment=$song_info['comment'];
	$warning=$song_info['warning'];

	$hours= $song_info['hours'];
	$mins = $song_info['mins'];

	$secs = $song_info['secs'];

	if ($secs<10)
	{	$secs="0$secs";
	}

	$title = $song_info['title'];
	$label1 = $song_info['label1'];
	$label2 = $song_info['label2'];
	$label3 = $song_info['label3'];
	$urltype = $song_info['urltype'];

	$url = $song_info['url'];

	if ($urltype=="STRM")
	{	$fulllocalpath=$url;
	}

	$vocals = $song_info['vocals'];

	$profanity = $song_info['profanity'];
	$volumewarning = $song_info['volumewarning'];
	$disturbing = $song_info['disturbing'];
	$grating = $song_info['grating'];
	$nonewlabel = $song_info['nonewlabel'];
	

	$new = $song_info['whendate'];

	switch ($urltype)
	{	case "OCR": $urltype="OcRemix"; break;
		case "VGMX": $urltype="VGMix X"; break;
		case "WEB":
		case "DL": $urltype="Web Download"; break;
	}

	if ($vocals=="y")
	{	$vocals="Vocals";
	}
	else
	{	unset($vocals);
	}
	if ($profanity=="y")
	{	$profanity="Profanity";
	}
	else
	{	unset($profanity);
	}
	if ($disturbing=="y")
	{	$disturbing="Disturbing";
	}
	else
	{	unset($disturbing);
	}
	if ($grating=="y")
	{	$grating="Grating";
	}
	else
	{	unset($grating);
	}
	if ($volumewarning=="y")
	{	$volumewarning="Volume";
	}
	else
	{	unset($volumewarning);
	}

	if (!$shortlist)	//Then we want to print the planet labels.
	{
		if ($prevlabel1!=$label1) //Then, we're at a new planet label.
		{
			$planetname=NumToPlanet($label1);
			$planame=NumToPla($label1);

			if ($outputfiles && $multipage && $label1>1)
				//Then, we want to output a file for the old planet
				//label.
			{	$prevplanetname=strtolower(NumToPlanet($label1-1));
				if ($private)
				{	
					$openthis=$privatepath . $prevplanetname . ".shtml";
				}
				else //if public
				{	$openthis=$mainpublicpath . $prevplanetname . ".shtml";
				}
				$filehandle = fopen($openthis, "w");
				$displaytext.= "<center>$planetlinkbar</center>";
				$displaytext= ereg_replace("  ", " ", $displaytext);
				$displaytext= ereg_replace("  ", " ", $displaytext);

				$outputtext .= $displaytext;
				$outputtext .= GetPageFooter(1);

				fwrite ($filehandle, $outputtext);
				fclose ($filehandle);

				echo $displaytext;

				$outputtext = GetPageHeader("Astrosorted Music - $planetname");
				$displaytext = "";

				$outputtext .= $pagetoptemplate;
			}

			//And then we get started building up the new planet's
			//section.

			$lcplanetname=strtolower($planetname);

			$displaytext .= "<a name=\"$lcplanetname\"></a><p>";
			$displaytext .= "<center>$planetlinkbar<p>";

			$displaytext .= "<h2>$planetname</h2></center><p>\n\n";
		}

		if ($prevlabel2!=$label2)
		{
			$planetname2=NumToPlanet($label2);
			$planame2=NumToPla($label2);
		}
		if ($prevlabel3!=$label3)
		{	
			$planetname3=NumToPlanet($label3);
			$planame3=NumToPla($label3);
		}
		
		if ( ($prevlabel1 != $label1) || ($prevlabel2 != $label2) || ($prevlabel3 != $label3) )
			//Then it's time to print a new subheader, like, for example,
			//Mercury/Mars/Neptune.
		{
			$displaytext .= "<a name=\"$planame-$planame2-$planame3\"></a>
<h3>$planetname/$planetname2/$planetname3";
			if ($label3==0)
			{	$displaytext=substr($displaytext,0,-1);
			}
			$displaytext .= "</h3>";
		}
	}
	else	//if shortlist, we don't want to bother with planet labels.
	{	
		if ($prevurltype!=$urltype)
		{	$displaytext .= "<h3 class='ash3'>$urltype</h3>\n\n";
		}
	}

	//Ho, hum.  A long, dull stretch where we add the song info 
	//and various formatting to the display string.

	$displaytext .= "<li";
	if ($shortlist)
	{	$displaytext .=" class='asli'";
	}
	$displaytext .= ">";

	if ($private)
	{	$displaytext .= "<a href=\"$fulllocalpath\">";
	}
	else
	{	$displaytext .= "<a href=\"$url\">";
	}

	$displaytext .= "$sourcenames[$song_id] - $title</a>";

	if (!$shortlist)
	{	$displaytext .= " $sublabels";
	};

	if ($new>$newsince)
	{	if (!$shortlist)
		{	if ($nonewlabel=="n")
			{	
				$displaytext .= " <span class=\"n\">New</span>";
			}
		}
	}

	if ($displayeditlinks)
	{	$displaytext .= " <a href=\"$editpath$song_id\">Edit</a>";
	}

	if (!$shortlist)
	{	$displaytext .="<br>$urltype &nbsp;&nbsp; ";
	}
	else
	{	$displaytext .= "<br>";
	}

	$displaytext .= "<span class=\"l\">";
		
	if (!$private)
	{	$displaytext .= "<b>Length:</b> ";
		if ($hours)
		{	$displaytext .= "$hours:";
		}	
		$displaytext .= "$mins:$secs";
	}

	if (!$private)
	{	$displaytext .= " &nbsp;&nbsp; <b>File Size:</b> ";

		$res = $filesize/1000000;

		$res=number_format($res,"2"); 

		$displaytext .= "$res MB";
	}

	$displaytext .= " &nbsp; ";
	if ($vocals)
	{	$displaytext .= "<span class=\"v\"> $vocals</span>";
	}	

	if ($profanity || $volumewarning || $disturbing || $grating)
	{
		$displaytext .= "<span class=\"w\"> $profanity $volumewarning $disturbing $grating</span>";
	}

	$displaytext .= "</span><br>
$performernames[$song_id]";

	if ($warning)
	{	$displaytext .= "<p><span class=\"w\"><b>Warning:</b></span> $warning";
	}
	if ($comment)
	{	$displaytext .= "<p><b>Comment:</b> $comment";
	}

	$displaytext .= "</li><p>\n\n";

	//OK, now we change the $prev--- variables to the now-current
	//variables, just before the while loop begins again.

	$prevlabel1=$label1;
	$prevlabel2=$label2;
	$prevlabel3=$label3;
	$prevurltype=$urltype;

	$x++;

}

//Then, since the loop stopped before printing Pluto, we print out
//the Pluto stuff by hand, and output it to a file later on (if
//the user asked for output files).

$displaytext .= "<center>$planetlinkbar</center>";
$displaytext = ereg_replace("  ", " ", $displaytext);
$displaytext = ereg_replace("  ", " ", $displaytext);

$outputtext .= $displaytext;
$outputtext .= GetPageFooter(1);

echo $displaytext;

echo "</ol>";

$displaytext="";

if ($musicianlinks)	//If the user asked for a list of musicians,
				//we create it now.
{
	$query_to_issue = "SELECT vgNameURLs.nameurl, vgNameURLs.entity_id, vgNameURLs.spelling_id, vgNames.name, vgNameURLs.nameurltype, unix_timestamp(vgNameURLs.whenadded) as whendate

FROM vgNameURLs, vgNames

WHERE vgNames.spelling_id = vgNameURLs.spelling_id
AND vgNameURLS.nameurltype != 'oops'
AND vgNameURLS.temphide = 'n'
AND vgNameURLs.permhide = 'n'
AND vgNames.temphide = 'n'
AND vgNames.permhide = 'n'
AND vgNames.nametype IN ('Musician', 'Group')";

	if ($shortlist)
	{	$query_to_issue .= "AND unix_timestamp(vgNameURLs.whenadded)>$newsince ";
	}

$query_to_issue .= "ORDER BY name, entity_id, spelling_id, nameurltype ASC";


	$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error());

	$numrows=mysql_num_rows($query_result);

	if (!$shortlist)
	{
		$outputtext2 = GetPageHeader("Musician Links");
		$outputtext2 .= GetCss("musicians");
		$outputtext2 .= GetPageSubheader(2);
		$outputtext2 .= GetMusiciansPageText();

	//First, we make the list of names for the top of the page 
	//which link to anchors lower down on the page.

		$allnamelinks = "<p><br><div class=\"musinavanchs\">";
	}
	
	if ($numrows>0)
	{
		$x=0;
		while ($info[$x] = mysql_fetch_array($query_result) )
		{	$entity_id=$info[$x]['entity_id'];
			$spelling_id=$info[$x]['spelling_id'];
			$name=$info[$x]['name'];
			$new=$info[$x]['whendate'];

			if ($prevspelling_id!=$spelling_id || $x==0)
			{	
				$spellings[$entity_id] .= "$name, ";
				$name = ereg_replace(" ", "&nbsp;", $name);
				$allnamelinks .= "<a href=\"#$entity_id\">$name</a> | ";
			}

			$url=$info[$x]['nameurl'];
			$urltype=$info[$x]['nameurltype'];

			switch ($urltype)
			{	case "OHP":	$urltype="Official Home Page"; break;
				case "OCR": $urltype="OCRemix Profile"; break;
				case "VGMX": $urltype="Vgmix X Profile"; break;
				case "MYSP": $urltype="MySpace Page"; break;
				case "UTUBE": $urltype="YouTube Profile"; break;
				case "LFM": $urltype="Last.fm Profile"; break;
				case "SCL": $urltype="SoundClick Profile"; break;
				case "INFO": $urltype="Informational Page"; break;
			}

			if ($new>$newsince && !$shortlist)
			{	$rednew=" <span class=\"n\">New</span>";
			}
			else
			{	$rednew="";
			}
			if ($urltype=="Official Home Page")
				//Then we want it displayed first, before any of the other
				//URLs.
			{
				$urls[$entity_id] = "<li><a href=\"$url\">$urltype</a>$rednew<br>$url\n<p>\n" . $urls[$entity_id];
			}
			else
			{
				$urls[$entity_id] .= "<li><a href=\"$url\">$urltype</a>$rednew<br>$url\n<p>\n";
			}

			$prevspelling_id=$spelling_id;

			if ($preventity_id!=$entity_id && $x!=0)
			{
				$thespellings=restrimcomma($spellings[$preventity_id]);
				$musicianblurbs[$preventity_id]="<p><br><br>\n\n<a name=\"$preventity_id\"><hr width=25% ></a>\n<h2>$thespellings</h2>\n\n<table width=50% class=\"musi\"><tr><td><br><big><center>$urls[$preventity_id]</table>";

			}

			$preventity_id=$entity_id;

			$x++;
		}

mysql_data_seek($query_result,0);

$x=0;
		while ($info[$x] = mysql_fetch_array($query_result) )
		{	$entity_id=$info[$x]['entity_id'];
			if ( ($preventity_id!=$entity_id && (!$printed[$preventity_id]) ) || $x=0)
			{
				$outputtext3 .= $musicianblurbs[$preventity_id];
				$printed[$preventity_id]="true";
			}
			$preventity_id=$entity_id;
			$x++;
		}

		

		//Then, since, like Pluto, the last name is missed by the while
		//loop, we repeat the procedure manually for the last musician.

		trimcomma($spellings[$preventity_id]);
		$outputtext3 .= "<p><br><br>\n\n<a name=\"$preventity_id\"><hr width=25% ></a>\n<h2>$spellings[$preventity_id]</h2>\n\n<table width=50% class=\"musi\"><tr><td><br><big><center>$urls[$preventity_id]</table></center>";

		$allnamelinks = substr($allnamelinks, 0, -2);

		$displaytext .= $allnamelinks . "</div><center><span class=\"exts\">" . $outputtext3 . "</span>";
		$outputtext2 .= $displaytext;

			// And, we finish the page.
		$outputtext2 .= "<p><br>";
		$outputtext2 .= GetPageFooter(2);
	}
	

}

//And display it.

echo $displaytext;


if ($outputfiles)	//then, we output the files.
{	
	if ($private)
	{	if ($multipage)
		{	$openthis=$privatepath . "pluto.shtml";

		}
		else
		{
			$openthis=$privatepath . "Astrosort.html";
		}
	
	}
	else 
	{	if ($multipage)
		{	$openthis = $mainpublicpath . "pluto.shtml";
		}
		else
		{	$openthis = $mainpublicpath . "musiclist.shtml";
		}
	}
	$filehandle = fopen($openthis, "w");
	fwrite ($filehandle, $outputtext);
	fclose ($filehandle);

	if ($musicianlinks)
	{	$openthis = $otherpublicpath . "musicianlinks.shtml";

		$filehandle = fopen($openthis, "w");
		fwrite ($filehandle, $outputtext2);
		fclose ($filehandle);
	}
}

//The end!!!!

?>